'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.3.1
// Export Plugin
module.exports = function (BasePlugin) {
  var MarkedPlugin;
  return MarkedPlugin = function () {
    // Define Plugin
    var MarkedPlugin = function (_BasePlugin) {
      _inherits(MarkedPlugin, _BasePlugin);

      function MarkedPlugin() {
        _classCallCheck(this, MarkedPlugin);

        return _possibleConstructorReturn(this, (MarkedPlugin.__proto__ || Object.getPrototypeOf(MarkedPlugin)).apply(this, arguments));
      }

      _createClass(MarkedPlugin, [{
        key: 'render',

        // Render some content
        value: function render(opts, next) {
          var config, inExtension, marked, outExtension, renderer;
          // Prepare
          config = this.config;

          // Check our extensions
          inExtension = opts.inExtension;
          outExtension = opts.outExtension;
          if ((inExtension === 'md' || inExtension === 'markdown') && (outExtension === null || outExtension === 'html')) {
            // Requires
            marked = require('marked');
            marked.setOptions(config.markedOptions);
            if (config.markedRenderer) {
              renderer = new marked.Renderer();
              Object.keys(config.markedRenderer).forEach(function (key) {
                return renderer[key] = config.markedRenderer[key];
              });
              return marked(opts.content, {
                renderer: renderer
              }, function (err, result) {
                opts.content = result;
                return next(err);
              });
            }
            // Render
            // use async form of marked in case highlight function requires it
            return marked(opts.content, function (err, result) {
              opts.content = result;
              return next(err);
            });
          } else {
            // Done
            return next();
          }
        }
      }]);

      return MarkedPlugin;
    }(BasePlugin);

    ;

    // Plugin name
    MarkedPlugin.prototype.name = 'marked';

    // Plugin configuration
    MarkedPlugin.prototype.config = {
      markedOptions: {
        pedantic: false,
        gfm: true,
        sanitize: false,
        highlight: null
      }
    };

    return MarkedPlugin;
  }.call(this);
};